-----------------------------------------------------------------------------------------------
-- Client Lua Script for YetAnotherCombatMod
-- Copyright (c) NCsoft. All rights reserved
-----------------------------------------------------------------------------------------------

-----------------------------------------------------------------------------------------------
-- Constants
-----------------------------------------------------------------------------------------------

local SystemKeyMap = {
	[8] = "Backspace", [9] = "Tab",
	
	[13] = "Enter",
	
	[16] = "Shift", [17] = "Ctrl",
	
	[19] = "Pause Break", [20] = "Caps Lock",
	
	[27] = "Esc",
	
	[32] = "Space", [33] = "Page Up", [34] = "Page Down", [35] = "End", [36] = "Home", [37] = "Left", [38] = "Up", [39] = "Right", [40] = "Down",
	
	[45] = "Insert", [46] = "Delete",
	
	[48] = "0", [49] = "1", [50] = "2", [51] = "3", [52] = "4", [53] = "5", [54] = "6", [55] = "7", [56] = "8", [57] = "9",
	
	[65] = "A", [66] = "B", [67] = "C", [68] = "D", [69] = "E", [70] = "F", [71] = "G", [72] = "H",	[73] = "I",	[74] = "J",	[75] = "K", 
	[76] = "L",	[77] = "M",	[78] = "N",	[79] = "O",	[80] = "P",	[81] = "Q",	[82] = "R",	[83] = "S",	[84] = "T",	[85] = "U",	[86] = "V",
	[87] = "W",	[88] = "X",	[89] = "Y",	[90] = "Z",	[91] = "Left Windows",	[92] = "Right Windows", [93] = "Menu Key",
	
	[96] = "Num 0", [97] = "Num 1",	[98] = "Num 2",	[99] = "Num 3",	[100] = "Num 4", [101] = "Num 5", [102] = "Num 6", [103] = "Num 7",
	[104] = "Num 8", [105] = "Num 9", [106] = "Num *", [107] = "Num +",
	
	[109] = "Num -", [110] = "Num Del", [111] = "Num /", [112] = "F1", [113] = "F2", [114] = "F3", [115] = "F4", [116] = "F5", [117] = "F6",
	[118] = "F7", [119] = "F8", [120] = "F9", [121] = "F10", [122] = "F11", [123] = "F12",
	
	[144] = "Num Lock", [145] = "Scroll Lock",
	
	[174] = "Special Key 1", [175] = "Special Key 2",
	
	[179] = "Special Key 3",
	
	[183] = "Special Key 4",
	
	[186] = ";", [187] = "=", [188] = ",", [189] = "-", [190] = ".", [191] = "/", [192] = "`",
	
	[219] = "[", [220] = "\\", [221] = "]", [222] = "'", [223] = "`",
	
	[226] = "\\"
}

local nCodeKeyMap  = {
	[1] = "Esc", [2] = "1", [3] = "2", [4] = "3", [5] = "4", [6] = "5", [7] = "6", [8] = "7", [9] = "8", [10] = "9",
	[11] = "0", [12] = "-", [13] = "=", [14] = "Backspace", [15] = "Tab", [16] = "Q", [17] = "W", [18] = "E", [19] = "R", [20] = "T", [21] = "Y", [22] = "U",
	[23] = "I", [24] = "O", [25] = "P", [26] = "[", [27] = "]",
	
	[29] = "Ctrl", -- L
	[30] = "A",	[31] = "S", [32] = "D",	[33] = "F", [34] = "G",	[35] = "H", [36] = "J",	[37] = "K", [38] = "L",	[39] = ";", [40] = "'",	[41] = "`",
	[42] = "Shift", -- L
	[43] = "\\", [44] = "Z", [45] = "X", [46] = "C", [47] = "V",	[48] = "B", [49] = "N",	[50] = "M", [51] = ",",	[52] = ".",

	[54] = "Shift", -- R
	[55] = "Num *",
	
	[56] = "Alt", [57] = "Space", [58] = "Caps Lock", [59] = "F1", [60] = "F2", [61] = "F3", [62] = "F4", [63] = "F5", [64] = "F6", [65] = "F7",
	[66] = "F8", [67] = "F9", [68] = "F10", [69] = "Pause", [70] = "Scroll Lock", [71] = "Num 7", [72] = "Num 8", [73] = "Num 1", [74] = "Num -", [75] = "Num 4",
	[76] = "Num 5", [77] = "Num 6", [78] = "Num +",	[79] = "Num 9", [80] = "Num 2", [81] = "Num 3", [82] = "Num 0", [83] = "Num Del",
	
	[87] = "F11", [88] = "F12",
    
	[256] = "Unknown",

    [285] = "Ctrl", -- R
	
	[309] = "Num /",	

	[312] = "Right Alt",
	
	[325] = "Num Lock",
	
	[327] = "Home", [328] = "Up", [329] = "Page Up",
	
	[331] = "Left",
	
	[333] = "Right",
	
	[335] = "End", [336] = "Down", [337] = "Page Down", [338] = "Insert", [339] = "Delete",
	
	[347] = "Left Windows"
}

local System2nCodeKeyMap = {
	[8] = 14, [9] = 15,
	
	[13] = nil,
	
	[16] = nil, [17] = nil,
	
	[19] = 69, [20] = 58,
	
	[27] = 1,
	
	[32] = 57, [33] = 329, [34] = 337, [35] = 335, [36] = 327, [37] = 331, [38] = 328, [39] = 333, [40] = 336,
	
	[45] = 338, [46] = 339,
	
	[48] = 11, [49] = 2, [50] = 3, [51] = 4, [52] = 5, [53] = 6, [54] = 7, [55] = 8, [56] = 9, [57] = 10,
	
	[65] = 30, [66] = 48, [67] = 46, [68] = 32, [69] = 18, [70] = 33, [71] = 34, [72] = 35, [73] = 23,	[74] = 36,	[75] = 37, 
	[76] = 38,	[77] = 50,	[78] = 49,	[79] = 24,	[80] = 25,	[81] = 16,	[82] = 19,	[83] = 31,	[84] = 20,	[85] = 22,	[86] = 47,
	[87] = 17,	[88] = 45,	[89] = 21,	[90] = 44,	[91] = 347,	[92] = nil, [93] = nil,
	
	[96] = 82, [97] = 73,	[98] = 80,	[99] = 81,	[100] = 75, [101] = 76, [102] = 77, [103] = 71,
	[104] = 72, [105] = 79, [106] = 55, [107] = 78,
	
	[109] = 74, [110] = 83, [111] = 309, [112] = 59, [113] = 60, [114] = 61, [115] = 62, [116] = 63, [117] = 64,
	[118] = 65, [119] = 66, [120] = 67, [121] = 68, [122] = 87, [123] = 88,
	
	[144] = 325, [145] = 70,
	
	[174] = 256, [175] = 256,
	
	[179] = 256,
	
	[183] = 256,
	
	[186] = 39, [187] = 13, [188] = 51, [189] = 12, [190] = 52, [191] = nil, [192] = 41,
	
	[219] = 26, [220] = 43, [221] = 27, [222] = 40, [223] = nil,
	
	[226] = nil
}

local Action2Text = {
	["None"] = "None",
	["LimitedActionSet1"] = "Skill 1",
	["LimitedActionSet2"] = "Skill 2",
	["LimitedActionSet3"] = "Skill 3",
	["LimitedActionSet4"] = "Skill 4",
	["LimitedActionSet5"] = "Skill 5",
	["LimitedActionSet6"] = "Skill 6",
	["LimitedActionSet7"] = "Skill 7",
	["LimitedActionSet8"] = "Skill 8",
	["CastGadgetAbility"] = "Gadget Skill",
	["CastPathAbility"] = "Path Skill",
	["DirectionalDash"] = "Dash",
	["ToggleAutoRun"] = "Auto Run",
}	

local ModifierMap = {
	[2] = "CTRL",
	[4] = "ALT",
	[6] = "CTRL-ALT"
}

-----------------------------------------------------------------------------------------------
-- Basic Functions
-----------------------------------------------------------------------------------------------

require "Window"

local YetAnotherCombatMod = {} 

Apollo.RegisterAddon(YetAnotherCombatMod, true, "YetAnotherCombatMod");

local Settings = {
	StickyTargeting = true,
	TargetMouseOver = true,
	TargetKey = 84,
	UseTargetKey = false,
	
	NormalTargetFilter = {
		Friendly = true,
		Hostile = true,
		Neutral = false
	},
	
	CombatTargetFilter = {
		Friendly = false,
		Hostile = true,
		Neutral = false
	}
}

local MBActions = {
	LMB = "LimitedActionSet1",
	MMB = "None",
	MB4 = "None",
	MB5 = "None",
	RMB = "LimitedActionSet2",
}

-- SetKeyBind
function YetAnotherCombatMod:SetKeyBind(Set, Index, Input)
	local Player = GameLib.GetPlayerUnit();
	if (Player ~= nil) then
		if (not Player:IsInCombat()) then
			if (self.KeyBindings[Index] ~= nil) then
				-- Print (KeyBindings[Index].strAction .. " (" .. Set .. ") bound to: " .. Input.eDevice .. " " .. Input.eModifier .. " " .. Input.nCode);

				self.KeyBindings[Index].arInputs[Set].eDevice = Input.eDevice;
				self.KeyBindings[Index].arInputs[Set].eModifier = Input.eModifier;
				self.KeyBindings[Index].arInputs[Set].nCode = Input.nCode;

				self.ApplyBindsButton:SetActionData(GameLib.CodeEnumConfirmButtonType.SaveKeyBinding, self.KeyBindings);
			end
		end
	end
end

-- DiscoverKeyBinds
function YetAnotherCombatMod:DiscoverKeyBinds()
	local InputSet = GameLib.GetCurrInputKeySet();
	
	if (InputSet == GameLib.CodeEnumInputSets.Account) then
		self.AccountCheckbox:SetCheck(true);
		self.CharacterCheckbox:SetCheck(false);
	elseif (InputSet == GameLib.CodeEnumInputSets.Character) then
		self.CharacterCheckbox:SetCheck(true);
		self.AccountCheckbox:SetCheck(false);
	end
		
	-- Assume nothing...
	MBActions["LMB"] = "None";
	MBActions["RMB"] = "None";
	MBActions["MMB"] = "None";
	MBActions["MB4"] = "None";
	MBActions["MB5"] = "None";
	
	self.KeyBindings = GameLib.GetKeyBindings();
	
	local Player = GameLib.GetPlayerUnit();
	if (Player ~= nil) then
		for i in ipairs(self.KeyBindings) do
			-- Print(KeyBindings[i].strAction);
			
			-- ToggleKey
			if (self.KeyBindings[i].strAction == "ExplicitMouseLook") then
				self.ToggleKey.eDevice = self.KeyBindings[i].arInputs[1].eDevice;
				self.ToggleKey.eModifier = self.KeyBindings[i].arInputs[1].eModifier;
				self.ToggleKey.nCode = self.KeyBindings[i].arInputs[1].nCode;
			end
			
			-- HoldKey
			if (self.KeyBindings[i].strAction == "ExplicitMouseLookHold") then
				self.HoldKey.eDevice = self.KeyBindings[i].arInputs[1].eDevice;
				self.HoldKey.eModifier = self.KeyBindings[i].arInputs[1].eModifier;
				self.HoldKey.nCode = self.KeyBindings[i].arInputs[1].nCode;
			end

			-- LeftMouseButton
			if (self.KeyBindings[i].arInputs[3].eDevice == 2 and self.KeyBindings[i].arInputs[3].eModifier == 0 and self.KeyBindings[i].arInputs[3].nCode == 0) then
				if (MBActions["LMB"] ~= self.KeyBindings[i].strAction) then
					MBActions["LMB"] = self.KeyBindings[i].strAction;
					-- Print ("Discovered " .. self.KeyBindings[i].strAction .. " as LMB.");
				end
			end	
					
			-- RightMouseButton
			if (self.KeyBindings[i].arInputs[3].eDevice == 2 and self.KeyBindings[i].arInputs[3].eModifier == 0 and self.KeyBindings[i].arInputs[3].nCode == 1) then
				if (MBActions["RMB"] ~= self.KeyBindings[i].strAction) then
					MBActions["RMB"] = self.KeyBindings[i].strAction;
					-- Print ("Discovered " .. self.KeyBindings[i].strAction .. " as RMB.");
				end
			end
					
			-- MiddleMouseButton
			if (self.KeyBindings[i].arInputs[3].eDevice == 2 and self.KeyBindings[i].arInputs[3].eModifier == 0 and self.KeyBindings[i].arInputs[3].nCode == 2) then
				if (MBActions["MMB"] ~= self.KeyBindings[i].strAction) then
					MBActions["MMB"] = self.KeyBindings[i].strAction;
					-- Print ("Discovered " .. self.KeyBindings[i].strAction .. " as MMB.");
				end
			end
					
			-- MouseButton4
			if (self.KeyBindings[i].arInputs[3].eDevice == 2 and self.KeyBindings[i].arInputs[3].eModifier == 0 and self.KeyBindings[i].arInputs[3].nCode == 3) then
				if (MBActions["MB4"] ~= self.KeyBindings[i].strAction) then
					MBActions["MB4"] = self.KeyBindings[i].strAction;
					-- Print ("Discovered " .. self.KeyBindings[i].strAction .. " as MB4.");
				end
			end
					
			-- MouseButton5
			if (self.KeyBindings[i].arInputs[3].eDevice == 2 and self.KeyBindings[i].arInputs[3].eModifier == 0 and self.KeyBindings[i].arInputs[3].nCode == 4) then
				if (MBActions["MB5"] ~= self.KeyBindings[i].strAction) then
					MBActions["MB5"] = self.KeyBindings[i].strAction;
					-- Print ("Discovered " .. self.KeyBindings[i].strAction .. " as MB5.");
				end
			end
		end
	end
end

-- OnConfigure
function YetAnotherCombatMod:OnConfigure()
	self.SettingsForm:Invoke();
	self.SettingsForm:SetInterrupt(true);
end

-- OnLoad
function YetAnotherCombatMod:OnLoad()
    -- Runtime Variables
	self.ScanTargetKey = false;
	self.ScanToggleKey = false;
	self.ScanHoldKey = false;
	self.KeyBindings = GameLib.GetKeyBindings();
	self.ListCaller = nil;
	
	self.ActionIndexes = {
		ExplicitMouseLook = 0,
		ExplicitMouseLookHold = 0,
		LimitedActionSet1 = 0,
		LimitedActionSet2 = 0,
		LimitedActionSet3 = 0,
		LimitedActionSet4 = 0,
		LimitedActionSet5 = 0,
		LimitedActionSet6 = 0,
		LimitedActionSet7 = 0,
		LimitedActionSet8 = 0,
		CastGadgetAbility = 0,
		CastPathAbility = 0,
		DirectionalDash = 0,
		ToggleAutoRun = 0
	}
	
	self.ToggleKey = { eDevice = 0, eModifier = 0, nCode = 0 };
	self.HoldKey = { eDevice = 0, eModifier = 0, nCode = 0};
	
	self.LMB = { eDevice = 2, eModifier = 0, nCode = 0 };
	self.RMB = { eDevice = 2, eModifier = 0, nCode = 1 };
	self.MMB = { eDevice = 2, eModifier = 0, nCode = 2 };
	self.MB4 = { eDevice = 2, eModifier = 0, nCode = 3 };
	self.MB5 = { eDevice = 2, eModifier = 0, nCode = 4 };
	
	self.EmptyKeyBind = { eDevice = 0, eModifier = 0, nCode = 0 };
	
	self.XML = XmlDoc.CreateFromFile("YetAnotherCombatMod.xml");
	self.XML:RegisterCallback("OnLoadXML", self);
end

-- OnLoadXML
function YetAnotherCombatMod:OnLoadXML()
	if (self.XML ~= nil and self.XML:IsLoaded()) then
		-- self.SettingsForm
		self.SettingsForm = Apollo.LoadForm(self.XML, "SettingsForm", nil, self);
				
		if (self.SettingsForm ~= nil) then
		    self.SettingsForm:Show(false, true);
		
			-- Buttons
			self.SetToggleKeyButton = self.SettingsForm:FindChild("SetToggleKeyButton");
			self.SetHoldKeyButton = self.SettingsForm:FindChild("SetHoldKeyButton");
			self.SetTargetKeyButton = self.SettingsForm:FindChild("SetTargetKeyButton");
			self.MBDropDownList = self.SettingsForm:FindChild("MBDropDownList");
			self.LMBDropDownButton = self.SettingsForm:FindChild("LMB");
			self.MMBDropDownButton = self.SettingsForm:FindChild("MMB");
			self.MB4DropDownButton = self.SettingsForm:FindChild("MB4");
			self.MB5DropDownButton = self.SettingsForm:FindChild("MB5");
			self.RMBDropDownButton = self.SettingsForm:FindChild("RMB");
			self.MouseActionsHeaderButton = self.SettingsForm:FindChild("MouseActionsHeaderButton");
			self.ApplyBindsButton = self.SettingsForm:FindChild("ApplyBindsButton");
			
			-- Checkboxes
			self.StickyTargetingCheckbox = self.SettingsForm:FindChild("StickyTargetingCheckbox");
			self.TargetMouseOverCheckbox = self.SettingsForm:FindChild("TargetMouseOverCheckbox");
			self.UseTargetKeyCheckbox = self.SettingsForm:FindChild("UseTargetKeyCheckbox");
			self.HostileUnitsCheckbox = self.SettingsForm:FindChild("HostileUnitsCheckbox");
			self.FriendlyUnitsCheckbox = self.SettingsForm:FindChild("FriendlyUnitsCheckbox");	
			self.NeutralUnitsCheckbox = self.SettingsForm:FindChild("NeutralUnitsCheckbox");
			
			self.CharacterCheckbox = self.SettingsForm:FindChild("CharacterCheckbox");	
			self.AccountCheckbox = self.SettingsForm:FindChild("AccountCheckbox");
						
			self.CombatHostileUnitsCheckbox = self.SettingsForm:FindChild("CombatHostileUnitsCheckbox");
			self.CombatFriendlyUnitsCheckbox = self.SettingsForm:FindChild("CombatFriendlyUnitsCheckbox");	
			self.CombatNeutralUnitsCheckbox = self.SettingsForm:FindChild("CombatNeutralUnitsCheckbox");

			-- Containers
			self.MouseActionsContainer = self.SettingsForm:FindChild("MouseActionsContainer");
			self.MouseTargetingContainer = self.SettingsForm:FindChild("MouseTargetingContainer");
			
			-- Initialization
			self.MouseActionsHeaderButton:SetCheck(true);
			self.StickyTargetingCheckbox:SetCheck(Settings["StickyTargeting"]);
			self.TargetMouseOverCheckbox:SetCheck(Settings["TargetMouseOver"]);
			self.UseTargetKeyCheckbox:SetCheck(Settings["UseTargetKey"]);
			
			if (Settings.NormalTargetFilter["Hostile"] == true) then self.HostileUnitsCheckbox:SetCheck(true); end
			if (Settings.NormalTargetFilter["Friendly"] == true) then self.FriendlyUnitsCheckbox:SetCheck(true); end
			if (Settings.NormalTargetFilter["Neutral"] == true) then self.NeutralUnitsCheckbox:SetCheck(true); end

			if (Settings.CombatTargetFilter["Hostile"] == true) then self.CombatHostileUnitsCheckbox:SetCheck(true); end
			if (Settings.CombatTargetFilter["Friendly"] == true) then self.CombatFriendlyUnitsCheckbox:SetCheck(true); end
			if (Settings.CombatTargetFilter["Neutral"] == true) then self.CombatNeutralUnitsCheckbox:SetCheck(true); end
			
			self:UpdateButtonText();
			self:UpdateButtonText();
			self:UpdateMBActionButtons();
		else Apollo.AddAddonErrorText(self, "Unable to load the SettingsForm."); end

		-- Clear XML
		self.XML = nil;

		-- Slash Commands
		Apollo.RegisterSlashCommand("yacm", "OnSlashCommand", self);

		-- Events
		Apollo.RegisterEventHandler("InterfaceMenuListHasLoaded", "OnInterfaceMenuListHasLoaded", self);
		Apollo.RegisterEventHandler("YACMInterfaceList", "OnSlashCommand", self);
		Apollo.RegisterEventHandler("MouseOverUnitChanged", "OnMouseOverUnitChange", self);
		Apollo.RegisterEventHandler("SystemKeyDown", "OnSystemKeyDown", self);
		Apollo.RegisterEventHandler("KeyBindingKeyChanged", "OnKeyBindingKeyChanged", self);
		Apollo.RegisterEventHandler("KeyBindingUpdated", "OnKeyBindingKeyChanged", self);
		Apollo.RegisterEventHandler("UnitEnteredCombat", "OnUnitEnteredCombat", self);

		-- Update UI
		self:UpdateActionIndexes();
		self:DiscoverKeyBinds();
		self:UpdateButtonText();
	end
end

--[[ Event Test
function YetAnotherCombatMod:OnEventTest()
	Print("TEST");
end
]]

-- OnRestore
function YetAnotherCombatMod:OnRestore(Level, Restore)
	if (Level == GameLib.CodeEnumAddonSaveLevel.Account) then
		if Restore.TargetKey ~= nil then Settings["TargetKey"] = Restore.TargetKey; end
		if Restore.StickyTargeting ~= nil then Settings["StickyTargeting"] = Restore.StickyTargeting; end
		if Restore.TargetMouseOver ~= nil then Settings["TargetMouseOver"] = Restore.TargetMouseOver; end
		if Restore.UseTargetKey ~= nil then Settings["UseTargetKey"] = Restore.UseTargetKey; end
		if Restore.NormalTargetFilter ~= nil then Settings.NormalTargetFilter = Restore.NormalTargetFilter; end
		if Restore.CombatTargetFilter ~= nil then Settings.CombatTargetFilter = Restore.CombatTargetFilter; end
				
		-- self:UpdateKeyBindIndexes();
	end
end

-- OnSave
function YetAnotherCombatMod:OnSave(Level)
	if (Level == GameLib.CodeEnumAddonSaveLevel.Account) then
		return Settings;
	else
		return
	end
end

-- SetTargetUnit
function YetAnotherCombatMod:SetTargetUnit(Unit)
	if (Unit) then
		local Player = GameLib.GetPlayerUnit();
		local Disposition = Unit:GetDispositionTo(Player);
		local SetTarget = false;
		
		if (Player:IsInCombat()) then
			local Disposition = Unit:GetDispositionTo(Player);
			if (Disposition == 0) then
				if (Settings.CombatTargetFilter["Hostile"] == true) then SetTarget = true; end
			elseif (Disposition == 1) then
				if (Settings.CombatTargetFilter["Neutral"] == true) then SetTarget = true; end
			elseif (Disposition == 2) then
				if (Settings.CombatTargetFilter["Friendly"] == true) then SetTarget = true; end
			end
		else
			local Disposition = Unit:GetDispositionTo(Player);
			if (Disposition == 0) then
				if (Settings.NormalTargetFilter["Hostile"] == true) then SetTarget = true; end
			elseif (Disposition == 1) then
				if (Settings.NormalTargetFilter["Neutral"] == true) then SetTarget = true; end
			elseif (Disposition == 2) then
				if (Settings.NormalTargetFilter["Friendly"] == true) then SetTarget = true; end
			end
		end
		
		if (SetTarget == true) then
			local AdditionalCondition = true;
			
			--[[ if (Settings["StickyTargeting"]) then
				local Target = GameLib.GetTargetUnit();
				if (Target) then
					local TargetDisposition = Target:GetDispositionTo(Player);
					
					-- AdditionalCondition = false;
				end
			else AdditionalCondition = true; end
			]]			

			if (AdditionalCondition == true) then
				GameLib.SetTargetUnit(Unit);
			end
		end
	else
		if (not Settings["StickyTargeting"]) then GameLib.SetTargetUnit(Unit); end
	end
end

-- UpdateActionIndexes
function YetAnotherCombatMod:UpdateActionIndexes()
	local Player = GameLib.GetPlayerUnit();
	if (Player ~= nil) then
		if (not Player:IsInCombat()) then
			for i in ipairs(self.KeyBindings) do
				-- Print(self.KeyBindings[i].strAction);
				
				for k,v in pairs(self.ActionIndexes) do
					if (self.KeyBindings[i].strAction == k) then
						self.ActionIndexes[k] = i;
						-- Print (i .. " " .. k);
					end
				end
			end
		end
	end
end

-- UpdateButtonText
function YetAnotherCombatMod:UpdateButtonText()
	local ToggleKeyText = "";
	
	if (self.ToggleKey.eModifier ~= 0) then
		if (ModifierMap[self.ToggleKey.eModifier] ~= nil) then ToggleKeyText = ModifierMap[self.ToggleKey.eModifier] .. "-"; else ToggleKeyText = self.ToggleKey.eModifier .. "-"; end
	end
	
	if (self.ToggleKey.nCode ~= 0) then 
		if (nCodeKeyMap[self.ToggleKey.nCode] ~= nil) then
			ToggleKeyText = ToggleKeyText .. nCodeKeyMap[self.ToggleKey.nCode];
		else ToggleKeyText = ToggleKeyText .. self.ToggleKey.nCode; end
	end
		
	self.SetToggleKeyButton:SetText(ToggleKeyText);
	
	local HoldKeyText = "";
	
	if (self.HoldKey.eModifier ~= 0) then
		HoldKeyText = ModifierMap[self.HoldKey.eModifier] .. "-";
	end
	
	if (self.HoldKey.nCode ~= 0) then 
		if (nCodeKeyMap[self.HoldKey.nCode] ~= nil) then
			HoldKeyText = HoldKeyText .. nCodeKeyMap[self.HoldKey.nCode];
		else HoldKeyText = HoldKeyText .. self.HoldKey.nCode; end
	end

	self.SetHoldKeyButton:SetText(HoldKeyText);
	
	if (SystemKeyMap[Settings["TargetKey"]]) then self.SetTargetKeyButton:SetText(SystemKeyMap[Settings["TargetKey"]]); else self.SetTargetKeyButton:SetText(Settings["TargetKey"]); end

	self.LMBDropDownButton:SetText(Action2Text[MBActions["LMB"]]);
	self.RMBDropDownButton:SetText(Action2Text[MBActions["RMB"]]);
	self.MMBDropDownButton:SetText(Action2Text[MBActions["MMB"]]);
	self.MB4DropDownButton:SetText(Action2Text[MBActions["MB4"]]);
	self.MB5DropDownButton:SetText(Action2Text[MBActions["MB5"]]);		
end

-- UpdateMBActionButtons
function YetAnotherCombatMod:UpdateMBActionButtons()
	local Unit = GameLib.GetPlayerUnit();
	if (Unit) then
		local Combat = Unit:IsInCombat();

		if (Combat == true) then
			self.LMBDropDownButton:Enable(false);
			self.RMBDropDownButton:Enable(false);
			self.MMBDropDownButton:Enable(false);
			self.MB4DropDownButton:Enable(false);
			self.MB5DropDownButton:Enable(false);
			self.SetToggleKeyButton:Enable(false);
			self.SetHoldKeyButton:Enable(false);
			self.ApplyBindsButton:Enable(false);
			self.MouseActionsContainer:SetTooltip("These settings cannot be changed while in combat.");
			
			self.MBDropDownList:Close();
			self.ListCaller = nil;
		else
			self.LMBDropDownButton:Enable(true);
			self.RMBDropDownButton:Enable(true);
			self.MMBDropDownButton:Enable(true);
			self.MB4DropDownButton:Enable(true);
			self.MB5DropDownButton:Enable(true);
			self.SetToggleKeyButton:Enable(true);
			self.SetHoldKeyButton:Enable(true);
			self.ApplyBindsButton:Enable(true);

			self.MouseActionsContainer:SetTooltip("");
		end
	end
end

-- Who
function YetAnotherCombatMod:Who()
	Print ("KeyBindings #: " .. #self.KeyBindings);
	Print ("Toggle Key: " .. self.ToggleKey.eDevice .. " " .. self.ToggleKey.eModifier .. " " .. self.ToggleKey.nCode);
	Print ("Toggle Key: " .. self.HoldKey.eDevice .. " " .. self.HoldKey.eModifier .. " " .. self.HoldKey.nCode);
	
	Print ("ActionIndexes:");
	Print (self.ActionIndexes["ExplicitMouseLook"] .. " " .. self.ActionIndexes["ExplicitMouseLookHold"] .. " " .. self.ActionIndexes["LimitedActionSet1"] .. " " .. self.ActionIndexes["LimitedActionSet2"]);
	Print (self.ActionIndexes["LimitedActionSet3"] .. " " .. self.ActionIndexes["LimitedActionSet4"] .. " " .. self.ActionIndexes["LimitedActionSet5"] .. " " .. self.ActionIndexes["LimitedActionSet6"]);
	Print (self.ActionIndexes["LimitedActionSet7"] .. " " .. self.ActionIndexes["LimitedActionSet8"] .. " " .. self.ActionIndexes["CastGadgetAbility"] .. " " .. self.ActionIndexes["CastPathAbility"]);
	Print (self.ActionIndexes["DirectionalDash"] .. " " .. self.ActionIndexes["ToggleAutoRun"]);
	
	Print ("Settings:");
	Print (MBActions["LMB"] .. " " .. MBActions["MMB"] .. " " .. MBActions["MB4"] .. " " .. MBActions["MB5"] .. " " .. MBActions["RMB"] .. " " .. Settings["TargetKey"]);
end

-----------------------------------------------------------------------------------------------
-- Slash Commands
-----------------------------------------------------------------------------------------------

-- OnSlashCommand
function YetAnotherCombatMod:OnSlashCommand()
	self:OnKeyBindingKeyChanged();
	
	if (self.SettingsForm:IsShown()) then
		self.SettingsForm:Close();
	else
		self.SettingsForm:Invoke();
		self.SettingsForm:SetInterrupt(true);
	end
end

-----------------------------------------------------------------------------------------------
-- Event Handlers
-----------------------------------------------------------------------------------------------

-- OnInterfaceMenuListHasLoaded
function YetAnotherCombatMod:OnInterfaceMenuListHasLoaded()
	Event_FireGenericEvent("InterfaceMenuList_NewAddOn", "YetAnotherCombatMod", {"YACMInterfaceList", "", ""});
end

-- OnKeyBindingKeyChanged
function YetAnotherCombatMod:OnKeyBindingKeyChanged()
	self:DiscoverKeyBinds();
	self:UpdateButtonText();
end

-- OnMouseOverUnitChange
function YetAnotherCombatMod:OnMouseOverUnitChange()
	if (Settings["TargetMouseOver"] and GameLib.IsMouseLockOn()) then
		local Unit = GetMouseOverUnit();
		self:SetTargetUnit(Unit);
	end
end

-- OnSystemKeyDown
function YetAnotherCombatMod:OnSystemKeyDown(SystemKey)
	-- if (SystemKeyMap[SystemKey] ~= nil) then Print (SystemKeyMap[SystemKey]); else Print (SystemKey); end
	
	if (self.ScanTargetKey) then
		self.ScanTargetKey = false;
		if (SystemKeyMap[SystemKey] ~= "Esc") then
			Settings["TargetKey"] = SystemKey;
			self:UpdateButtonText();
		else
			self.ScanToggleKey = false;
			self.ScanHoldKey = false;
			self:UpdateButtonText();
		end
	elseif (self.ScanToggleKey) then
		if (SystemKeyMap[SystemKey] ~= "Esc") then
			if (System2nCodeKeyMap[SystemKey] ~= nil) then
				self.ScanToggleKey = false;
				
				self.ToggleKey.eDevice = 1;
				if (Apollo.IsAltKeyDown() and Apollo.IsControlKeyDown()) then self.ToggleKey.eModifier = 6; elseif (Apollo.IsAltKeyDown()) then self.ToggleKey.eModifier = 4; elseif (Apollo.IsControlKeyDown()) then self.ToggleKey.eModifier = 2; else self.ToggleKey.eModifier = 0; end
				self.ToggleKey.nCode = System2nCodeKeyMap[SystemKey];
				
				self:SetKeyBind(1, self.ActionIndexes["ExplicitMouseLook"], self.ToggleKey);
	
				self:UpdateButtonText();
			end
		else
			self.ScanHoldKey = false;
			self.ScanToggleKey = false;
			self.ScanTargetKey = false;
			self:UpdateButtonText();
		end
	elseif (self.ScanHoldKey) then
		if (SystemKeyMap[SystemKey] ~= "Esc") then
			if (System2nCodeKeyMap[SystemKey] ~= nil) then
				self.ScanHoldKey = false;
				
				self.HoldKey.eDevice = 1;
				if (Apollo.IsAltKeyDown() and Apollo.IsControlKeyDown()) then self.HoldKey.eModifier = 6; elseif (Apollo.IsAltKeyDown()) then self.HoldKey.eModifier = 4; elseif (Apollo.IsControlKeyDown()) then self.HoldKey.eModifier = 2; else self.HoldKey.eModifier = 0; end
				self.HoldKey.nCode = System2nCodeKeyMap[SystemKey];

				self:SetKeyBind(1, self.ActionIndexes["ExplicitMouseLookHold"], self.HoldKey);
	
				self:UpdateButtonText();
			end
		else
			self.ScanToggleKey  = false;
			self.ScanHoldKey = false;
			self.ScanTargetKey = false;
			self:UpdateButtonText();
		end
	else
		if (Settings["UseTargetKey"] and SystemKey == Settings["TargetKey"] and GameLib.IsMouseLockOn()) then
			local MouseOverUnit = GetMouseOverUnit();
			self:SetTargetUnit(MouseOverUnit);
		end
	end
end

-- OnUnitEnteredCombat
function YetAnotherCombatMod:OnUnitEnteredCombat(Unit, Combat)
	if (Unit == GameLib.GetPlayerUnit()) then
		self:UpdateMBActionButtons();
	end
end

-----------------------------------------------------------------------------------------------
-- Form Handlers
-----------------------------------------------------------------------------------------------

-- OnCombatHostileUnitsOnlyCheck
function YetAnotherCombatMod:OnCombatHostileUnitsCheck() Settings.CombatTargetFilter["Hostile"] = true; end

-- OnCombatHostileUnitsOnlyUncheck
function YetAnotherCombatMod:OnCombatHostileUnitsUncheck() Settings.CombatTargetFilter["Hostile"] = false; end

-- OnCombatFriendlyUnitsOnlyCheck
function YetAnotherCombatMod:OnCombatFriendlyUnitsCheck() Settings.CombatTargetFilter["Friendly"] = true; end

-- OnCombatFriendlyUnitsOnlyUncheck
function YetAnotherCombatMod:OnCombatFriendlyUnitsUncheck() Settings.CombatTargetFilter["Friendly"] = false; end

-- OnCombatNeutralUnitsOnlyCheck
function YetAnotherCombatMod:OnCombatNeutralUnitsCheck() Settings.CombatTargetFilter["Neutral"] = true; end

-- OnCombatNeutralUnitsOnlyUncheck
function YetAnotherCombatMod:OnCombatNeutralUnitsUncheck() Settings.CombatTargetFilter["Neutral"] = false; end

-- OnFriendlyUnitsOnlyCheck
function YetAnotherCombatMod:OnFriendlyUnitsCheck() Settings.NormalTargetFilter["Friendly"] = true; end

-- OnFriendlyUnitsOnlyUncheck
function YetAnotherCombatMod:OnFriendlyUnitsUncheck() Settings.NormalTargetFilter["Friendly"] = false; end

-- OnHostileUnitsOnlyCheck
function YetAnotherCombatMod:OnHostileUnitsCheck() Settings.NormalTargetFilter["Hostile"] = true; end

-- OnHostileUnitsOnlyUncheck
function YetAnotherCombatMod:OnHostileUnitsUncheck() Settings.NormalTargetFilter["Hostile"] = false; end

-- OnInputSetChange
function YetAnotherCombatMod:OnInputSetChange( wndHandler, wndControl, eMouseButton )
	local CallerName = wndHandler:GetName();
	
	local InputSet = GameLib.CodeEnumInputSets.Account;
	local CurrInputSet = GameLib.GetCurrInputKeySet();
	
	if (CallerName == "CharacterCheckbox") then
		InputSet = GameLib.CodeEnumInputSets.Character;
	end
	
	if (InputSet ~= CurrInputSet) then
		self.ApplyBindsButton:SetActionData(0, nil);
		local Completed = GameLib.SetCurrInputKeySet(InputSet);
		
		if (Completed == true) then
			self:OnKeyBindingKeyChanged();
		end
	end
end

-- OnKeyboardHeaderCheck
function YetAnotherCombatMod:OnKeyboardHeaderCheck()
	self.MouseActionsContainer:Invoke();
end

-- OnKeyboardHeaderUncheck
function YetAnotherCombatMod:OnKeyboardHeaderUncheck()
	self.MouseActionsContainer:Close();
end

-- OnKeyBindingSaved
function YetAnotherCombatMod:OnKeyBindingSaved()
	self.ApplyBindsButton:SetActionData(0, nil);
end

-- OnMBActionSelect
function YetAnotherCombatMod:OnMBActionSelect(wndHandler, wndControl, eMouseButton)
	local Caller = self.ListCaller;
	if (Caller) then
		local CallerName = Caller:GetName();
	
		local Action = wndHandler:GetText();
		
		if (Action == "Skill 1") then
			Action = "LimitedActionSet1";
		elseif (Action == "Skill 2") then
			Action = "LimitedActionSet2";
		elseif (Action == "Skill 3") then
			Action = "LimitedActionSet3";
		elseif (Action == "Skill 4") then
			Action = "LimitedActionSet4";
		elseif (Action == "Skill 5") then
			Action = "LimitedActionSet5";
		elseif (Action == "Skill 6") then
			Action = "LimitedActionSet6";
		elseif (Action == "Skill 7") then
			Action = "LimitedActionSet7";
		elseif (Action == "Skill 8") then
			Action = "LimitedActionSet8";
		elseif (Action == "Gadget Skill") then
			Action = "CastGadgetAbility";
		elseif (Action == "Path Skill") then
			Action = "CastPathAbility";
		elseif (Action == "Dash") then
			Action = "DirectionalDash";
		elseif (Action == "Auto Run") then
			Action = "ToggleAutoRun";
		end
		
		if (Action ~= MBActions[CallerName]) then
			local Input1 = self.EmptyKeyBind;
			local Input2 = nil;
			
			if (CallerName == "LMB") then
				Input2 = self.LMB;
			elseif (CallerName == "RMB") then
				Input2 = self.RMB;
			elseif (CallerName == "MMB") then
				Input2 = self.MMB;
			elseif (CallerName == "MB4") then
				Input2 = self.MB4;
			elseif (CallerName == "MB5") then
				Input2 = self.MB5;
			end
			
			if (Action ~= "None") then
				if (Action == MBActions["RMB"]) then
					MBActions["RMB"] = MBActions[CallerName];
					Input1 = self.RMB;
				elseif (Action == MBActions["LMB"]) then
					MBActions["LMB"] = MBActions[CallerName];
					Input1 = self.LMB;
				elseif (Action == MBActions["MMB"]) then
					MBActions["MMB"] = MBActions[CallerName];
					Input1 = self.MMB;
				elseif (Action == MBActions["MB4"]) then
					MBActions["MB4"] = MBActions[CallerName];
					Input1 = self.MB4;
				elseif (Action == MBActions["MB5"]) then
					MBActions["MB5"] = MBActions[CallerName];
					Input1 = self.MB5;
				end
			end

			self:SetKeyBind(3, self.ActionIndexes[MBActions[CallerName]], Input1);
			self:SetKeyBind(3, self.ActionIndexes[Action], Input2);
			MBActions[CallerName] = Action;
			
			self:UpdateButtonText();
		end
	end

	self:OnMBDropDownButton();
end

-- OnMBDropDownButton
function YetAnotherCombatMod:OnMBDropDownButton(wndHandler, wndControl, eMouseButton)
	if (not wndHandler or not wndHandler:IsChecked()) then
		self.MBDropDownList:Close();
		self.ListCaller = nil;
	else
		self.MBDropDownList:Invoke();
		
		if (self.ListCaller) then self.ListCaller:SetCheck(false); end
		self.ListCaller = wndHandler;
	end
end

-- OnMBDropDownListClose
function YetAnotherCombatMod:OnMBDropDownListClose()
	self.ListCaller:SetCheck(false);
end

-- OnMouseTargetingHeaderButtonCheck
function YetAnotherCombatMod:OnCMIHeaderCheck()
	self.MouseTargetingContainer:Invoke();
end

-- OnMouseTargetingHeaderButtonUncheck
function YetAnotherCombatMod:OnCMIHeaderUncheck()
	self.MouseTargetingContainer:Close();
end

-- OnSetTargetKey
function YetAnotherCombatMod:OnSetTargetKey( wndHandler, wndControl, eMouseButton )
	self.ScanTargetKey = true;
	self:UpdateButtonText();
	self.SetTargetKeyButton:SetText("Waiting...");
end

-- OnSettingsFormClose
function YetAnotherCombatMod:OnSettingsFormClose()
	self.SettingsForm:Close() -- hide the window
	self:UpdateButtonText();
	self.ScanTargetKey = false;
	self.ScanToggleKey = false;
	self.ScanHoldKey = false;
end

-- OnTargetMouseOverCheck
function YetAnotherCombatMod:OnTargetMouseOverCheck() Settings["TargetMouseOver"] = true; end

-- OnTargetMouseOverUncheck
function YetAnotherCombatMod:OnTargetMouseOverUncheck()	Settings["TargetMouseOver"] = false; end

-- OnStickyTargetingCheck
function YetAnotherCombatMod:OnStickyTargetingCheck() Settings["StickyTargeting"] = true; end

-- OnStickyTargetingUncheck
function YetAnotherCombatMod:OnStickyTargetingUncheck() Settings["StickyTargeting"] = false; end

-- OnNeutralUnitsOnlyCheck
function YetAnotherCombatMod:OnNeutralUnitsCheck() Settings.NormalTargetFilter["Neutral"] = true; end

-- OnNeutralUnitsOnlyUncheck
function YetAnotherCombatMod:OnNeutralUnitsUncheck() Settings.NormalTargetFilter["Neutral"] = false; end

-- OnUseTargetKeyCheck
function YetAnotherCombatMod:OnUseTargetKeyCheck( wndHandler, wndControl, eMouseButton ) Settings["UseTargetKey"] = true; end

-- OnUseTargetKeyUncheck
function YetAnotherCombatMod:OnUseTargetKeyUncheck( wndHandler, wndControl, eMouseButton ) Settings["UseTargetKey"] = false; end

-- OnSetToggleKey
function YetAnotherCombatMod:OnSetToggleKey( wndHandler, wndControl, eMouseButton )
	self.ScanToggleKey = true;
	self:UpdateButtonText();
	self.SetToggleKeyButton:SetText("Waiting...");
end

-- OnSetHoldKey
function YetAnotherCombatMod:OnSetHoldKey( wndHandler, wndControl, eMouseButton )
	self.ScanHoldKey = true;
	self:UpdateButtonText();
	self.SetHoldKeyButton:SetText("Waiting...");
end

